
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class VaccinationsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const vaccinations = await db.vaccinations.create(
            {
                id: data.id || undefined,
        
        vaccine_name: data.vaccine_name
        ||
        null
            ,
            
        date_given: data.date_given
        ||
        null
            ,
            
        dose_number: data.dose_number
        ||
        null
            ,
            
        batch_number: data.batch_number
        ||
        null
            ,
            
        booster_due_date: data.booster_due_date
        ||
        null
            ,
            
        notes: data.notes
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await vaccinations.setUser( data.user || null, {
            transaction,
        });
        
        await vaccinations.setProvider( data.provider || null, {
            transaction,
        });
        

        

        

        return vaccinations;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const vaccinationsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                vaccine_name: item.vaccine_name
            ||
            null
            ,
            
                date_given: item.date_given
            ||
            null
            ,
            
                dose_number: item.dose_number
            ||
            null
            ,
            
                batch_number: item.batch_number
            ||
            null
            ,
            
                booster_due_date: item.booster_due_date
            ||
            null
            ,
            
                notes: item.notes
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const vaccinations = await db.vaccinations.bulkCreate(vaccinationsData, { transaction });

        // For each item created, replace relation files
        

        return vaccinations;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const vaccinations = await db.vaccinations.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.vaccine_name !== undefined) updatePayload.vaccine_name = data.vaccine_name;
        
        
        if (data.date_given !== undefined) updatePayload.date_given = data.date_given;
        
        
        if (data.dose_number !== undefined) updatePayload.dose_number = data.dose_number;
        
        
        if (data.batch_number !== undefined) updatePayload.batch_number = data.batch_number;
        
        
        if (data.booster_due_date !== undefined) updatePayload.booster_due_date = data.booster_due_date;
        
        
        if (data.notes !== undefined) updatePayload.notes = data.notes;
        
        
        updatePayload.updatedById = currentUser.id;

        await vaccinations.update(updatePayload, {transaction});

        
        
        if (data.user !== undefined) {
            await vaccinations.setUser(
              
              data.user,
              
              { transaction }
            );
        }
        
        if (data.provider !== undefined) {
            await vaccinations.setProvider(
              
              data.provider,
              
              { transaction }
            );
        }
        

        
        

        

        return vaccinations;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const vaccinations = await db.vaccinations.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of vaccinations) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of vaccinations) {
                await record.destroy({transaction});
            }
        });


        return vaccinations;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const vaccinations = await db.vaccinations.findByPk(id, options);

        await vaccinations.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await vaccinations.destroy({
            transaction
        });

        return vaccinations;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const vaccinations = await db.vaccinations.findOne(
            { where },
            { transaction },
        );

        if (!vaccinations) {
            return vaccinations;
        }

        const output = vaccinations.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.user = await vaccinations.getUser({
            transaction
        });
        
        
        output.provider = await vaccinations.getProvider({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.users,
        as: 'user',
        
        where: filter.user ? {
          [Op.or]: [
            { id: { [Op.in]: filter.user.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.user.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.healthcare_providers,
        as: 'provider',
        
        where: filter.provider ? {
          [Op.or]: [
            { id: { [Op.in]: filter.provider.split('|').map(term => Utils.uuid(term)) } },
            {
              provider_name: {
                [Op.or]: filter.provider.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.vaccine_name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'vaccinations',
                        'vaccine_name',
                        filter.vaccine_name,
                    ),
                };
            }
            
            if (filter.batch_number) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'vaccinations',
                        'batch_number',
                        filter.batch_number,
                    ),
                };
            }
            
            if (filter.notes) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'vaccinations',
                        'notes',
                        filter.notes,
                    ),
                };
            }
            

            
            
            if (filter.calendarStart && filter.calendarEnd) {
                where = {
                    ...where,
                    [Op.or]: [
                        {
                            date_given: {
                                [Op.between]: [filter.calendarStart, filter.calendarEnd],
                            },
                    },
                {
                    booster_due_date: {
                        [Op.between]: [filter.calendarStart, filter.calendarEnd],
                    },
                },
                ],
            };
            }
            

            
            if (filter.date_givenRange) {
                const [start, end] = filter.date_givenRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    date_given: {
                    ...where.date_given,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    date_given: {
                    ...where.date_given,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.dose_numberRange) {
                const [start, end] = filter.dose_numberRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    dose_number: {
                    ...where.dose_number,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    dose_number: {
                    ...where.dose_number,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.booster_due_dateRange) {
                const [start, end] = filter.booster_due_dateRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    booster_due_date: {
                    ...where.booster_due_date,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    booster_due_date: {
                    ...where.booster_due_date,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            


      

      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.vaccinations.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'vaccinations',
                        'vaccine_name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.vaccinations.findAll({
            attributes: [ 'id', 'vaccine_name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['vaccine_name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.vaccine_name,
        }));
    }

    
};

